//+------------------------------------------------------------------+
//|                                                  TradeOnNews.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//---- input parameters
extern int    Magic          = 111; //   
extern string StartTime      = "15:30";  //     (  MetaTrader)
extern string CloseTime      = "16:00";  //   
extern int    Delta          = 15;  //       
extern int    StopLoss       = 20;
extern int    TakeProfit     = 30;
extern double Lot            = 0.1;

int day, EP;
string Symb;

double   Mas_Ord[31][13];   //  
int      Mas_Tip[6];            //  .    // []  : 0=B,1=S,2=BL,3=SL,4=BS,5=SS
int      Mas_Tip_T[6];          //  .    -  
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   Symb = Symbol();    //  ..
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   int total = OrdersTotal(); //    
   Orders(); //    
   if(total > 1) //     -    
    {
     for(int i = 0; i < total; i ++)
      {
       if(OrderSelect(i, SELECT_BY_POS) == false) continue; //    ,    
       if(Magic != OrderMagicNumber()) continue;//        Magic -    
       if(Mas_Tip[0] > 0 //      -   
          && OrderType() == OP_SELLSTOP) //   
           OrderDelete(OrderTicket()); //  
       
       if(Mas_Tip[1] > 0 //      -   
          && OrderType() == OP_BUYSTOP) //   
           OrderDelete(OrderTicket()); //  
      }
    }
   if(total == 1 && Mas_Tip[4] > 0) //        
    {
     Expiration(); //   Expiration      
     OrderSend(Symb,OP_SELLSTOP,Lot,Bid-Delta*Point,3,Bid-Delta*Point + StopLoss*Point,Bid-Delta*Point - TakeProfit*Point,NULL,Magic,EP,Red); //  
    }
   if((total == 0) && (TimeCurrent() > StrToTime(StartTime)) && (TimeCurrent() < StrToTime(StartTime) + 60))
    { //                      60 
     Expiration(); //   Expiration      
     OrderSend(Symb,OP_BUYSTOP,Lot,Ask+Delta*Point,3,Ask+Delta*Point - StopLoss*Point,Ask+Delta*Point + TakeProfit*Point,NULL,Magic,EP,Blue); // 
    }
   return(0);
  }
//+------------------------------------------------------------------+
//      - ,   .          |
//+------------------------------------------------------------------+
int Orders()//  ... , ,  ,   .
 {
  int Qnt = 0;                          //   
  Qnt = 0;                              //   
  ArrayInitialize(Mas_Ord,0);       //  
  ArrayInitialize(Mas_Tip,0);           //  
  ArrayInitialize(Mas_Tip_T,0);         //  
  for(int i = 0; i < OrdersTotal(); i++)//  .  . 
   {
    if((OrderSelect(i,SELECT_BY_POS) == true) && (OrderSymbol() == Symb))//  .  //..   .
     {
      if(Magic != OrderMagicNumber()) continue;//        Magic -    
      Qnt++;                                            // .          
      Mas_Ord[Qnt][1] = OrderOpenPrice();           //   
      Mas_Ord[Qnt][2] = OrderStopLoss();            //  SL
      Mas_Ord[Qnt][3] = OrderTakeProfit();          //  
      Mas_Ord[Qnt][4] = OrderTicket();              //  
      Mas_Ord[Qnt][5] = OrderLots();                //  
      Mas_Tip[OrderType()]++;                           // .  
      Mas_Ord[Qnt][6] = OrderType();                //  
      Mas_Ord[Qnt][7] = OrderMagicNumber();         //  
      if(OrderComment() == "") Mas_Ord[Qnt][8] = 0; //   
      else Mas_Ord[Qnt][8] = 1;                     //   
      Mas_Ord[Qnt][9] = OrderOpenTime();            //   
      Mas_Ord[Qnt][10] = OrderCloseTime();          //   
      Mas_Ord[Qnt][11] = OrderExpiration();     //       .
      if(day == TimeDayOfYear(OrderOpenTime()))         //    ...
       {
        Mas_Tip_T[OrderType()]++;                       // .  ...  
       }
     }
   }
  Mas_Ord[0][0] = Qnt;                         // . 
  return;
 }
//+------------------------------------------------------------------+
//                                                                   |
//+------------------------------------------------------------------+
int Expiration()
 { //        -     (60*60*24)
  if(StrToTime(StartTime) > StrToTime(CloseTime)) EP = 60*60*24 + StrToTime(CloseTime);
    else EP = StrToTime(CloseTime); //         -  
 }
//+------------------------------------------------------------------+